;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ExAnimation-Based Shooter by MrCheeze (Going Right)
; Based off maro!!!'s One-Way Bullet Shooters
;
; Thanks to Azure for telling me the RAM address for ExAnimation
; And to Schwa for his ASM tutorial
;
; This shooter doesn't use the extra bit, and it doesn't generate smoke
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    dcb "INIT" 
                    dcb "MAIN"                                    
                    PHB                     
                    PHK                     
                    PLB                     
                    JSR SPRITE_CODE_START   
                    PLB                     
                    RTL      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main bullet bill shooter code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WRONGFRAME          LDA #$00                ; \ de-set already-shot flag
                    STA $1528,x             ; /
RETURN2             RTS                     ; return
SPRITE_CODE_START   LDA $7FC004             ; \ return if it's not right ExAnimation Frame
                    AND #$0F                ; |
                    CMP #$00                ; | FRAME TO SHOOT!
                    BNE WRONGFRAME          ; /
                    LDA $1528,x             ; \ return if already shot
                    CMP #$14                ; |
                    BEQ RETURN2             ; /
                    LDA $178B,x             ; \ don't generate if off screen vertically
                    CMP $1C                 ;  |
                    LDA $1793,x             ;  |
                    SBC $1D                 ;  |
                    BNE RETURN2             ; /
                    LDA $179B,x             ; \ don't generate if off screen horizontally
                    CMP $1A                 ;  |
                    LDA $17A3,x             ;  |
                    SBC $1B                 ;  |
                    BNE RETURN2             ; / 
                    LDA $179B,x             ; \ ?? something else related to x position of generator??
                    SEC                     ;  | 
                    SBC $1A                 ;  |
                    CLC                     ;  |
                    ADC #$10                ;  |
                    CMP #$10                ;  |
                    BCC RETURN2             ; /
                    JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN2             ; / after: Y has index of sprite being generated

GENERATE_SPRITE     LDA #$14                ; \ set already-shot flag
                    STA $1528,x             ; /
                    LDA #$09                ; \ SOUND EFFECT TO PLAY
                    STA $1DFC               ; /
                    LDA #$01                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    LDA #$1C                ; \ SPRITE TO GENERATE!
                    STA $009E,y             ; /
                    LDA $179B,x             ; \ set x position for new sprite
                    STA $00E4,y             ;  |
                    LDA $17A3,x             ;  |
                    STA $14E0,y             ; /
                    LDA $178B,x             ; \ set y position for new sprite
                    SEC                     ;  | (y position of generator - 1)
                    SBC #$01                ;  |
                    STA $00D8,y             ;  |
                    LDA $1793,x             ;  |
                    SBC #$00                ;  |
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX                     ; / 
                    LDA #$08                ;
                    STA $14C8,y             ;

                    LDA $00
                    PHA
                    
                    LDA $1783,x 
                    AND #$40
                    BEQ LEFT
                    
                    LDA $178B,x             ; check y position and shoot up or down accordingly
                    AND #$10                ; todo: change this check
                    BNE SHOOT_UP2
                    LDA #$03
                    BRA STORE
SHOOT_UP2           LDA #$03
                    BRA STORE

LEFT                LDA $178B,x             ; check y position and shoot up or down accordingly
                    AND #$10                ; todo: change this check
                    BNE SHOOT_UP
                    LDA #$00 
                    BRA STORE
SHOOT_UP            LDA #$00               
STORE               STA $00C2,y             ; 06 for down, 07 for up
                    STA $00
                    PLA
                    STA $00
                    
RETURN              RTS                     ; return
